Foreman - Bug #16197

Cannot rebuild when proxy from hostgroup is unreachable
08/19/2016 07:32 AM - Daniel Lobato Garcia

Status: Closed
Priority: Normal
Assignee: Daniel Lobato Garcia
Category: Smart Proxy
Target version: 1.12.3
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3752
Description

Doing the following:

- Create 2 smart proxies, one for dhcp/dns/tft/puppetca/puppet, another for realms. Let's keep the realms proxy off, so it's
unreachable.

- Create a hostgroup A that sets domain, subnet, realm, puppet_proxy, puppet_ca_proxy

- Create a host that uses hostgroup A, but uncheck 'inherit' and remove the 'realm' attribute. The host is created just fine with no
realm

- When | try to rebuild the host, "HostBuildStatus#check_all_statuses is called. This checks the host_status (OK),
templates_status(OK), and smart_proxies_status(FAIL). The host cannot be rebuilt.

The reason “smart_proxies_status’ fails is that “smart_proxy_ids’ tries to find whether Realm is set.

- If it's set, it adds the proxy to 'Host#smart_proxies’

- If it's not set, it looks in the hostgroup to see if it's set there. However, | have overridden the option, because | don't want to set a
Realm since | don't want to boot the Realm proxy | have.

Host#smart_proxies should not look in the host.hostgroup object to retrieve values for the proxy, but instead retrieve those from itself

Associated revisions

Revision 15f2f291 - 08/23/2016 06:48 AM - Daniel Lobato Garcia

Fixes #16197 - Host#smart_proxies returns only the host proxies

Doing the following:

- Create 2 smart proxies, one for dhcp/dns/tft/puppetca/puppet, another
for realms. Let's keep the realms proxy off, so it's unreachable.

- Create a hostgroup A that sets domain, subnet, realm, puppet_proxy,
puppet_ca_proxy

- Create a host that uses hostgroup A, but uncheck 'inherit' and
remove the 'realm’ attribute. The host is created just fine with no

realm

- When [ try to rebuild the host, "HostBuildStatus#check_all_statuses’
is called. This checks the host_status (OK), templates_status(OK), and
smart_proxies_status(FAIL). The host cannot be rebuilt.

The reason “smart_proxies_status’ fails is that “smart_proxy_ids®
tries to find whether Realm is set.

- If it's set, it adds the proxy to 'Host#smart_proxies’

- If it's not set, it looks in the hostgroup to see if it's set there.
However, | have overridden the option, because | don't want to set a
Realm since | don't want to boot the Realm proxy | have.

Host#smart_proxies should not look in the host.hostgroup object to
retrieve values for the proxy, but instead retrieve those from itself

Revision a49f2499 - 09/19/2016 11:59 AM - Daniel Lobato Garcia

Fixes #16197 - Host#smart_proxies returns only the host proxies

Doing the following:
- Create 2 smart proxies, one for dhcp/dns/tft/puppetca/puppet, another
for realms. Let's keep the realms proxy off, so it's unreachable.

- Create a hostgroup A that sets domain, subnet, realm, puppet_proxy,
puppet_ca_proxy

- Create a host that uses hostgroup A, but uncheck 'inherit' and
remove the 'realm’ attribute. The host is created just fine with no

realm

- When [ try to rebuild the host, "HostBuildStatus#check_all_statuses’
is called. This checks the host_status (OK), templates_status(OK), and
smart_proxies_status(FAIL). The host cannot be rebuilt.

The reason “smart_proxies_status’ fails is that “smart_proxy_ids®
tries to find whether Realm is set.

- If it's set, it adds the proxy to 'Host#smart_proxies’

- If it's not set, it looks in the hostgroup to see if it's set there.
However, | have overridden the option, because | don't want to set a
Realm since | don't want to boot the Realm proxy | have.

Host#smart_proxies should not look in the host.hostgroup object to
retrieve values for the proxy, but instead retrieve those from itself

(cherry picked from commit 15f2f2918f60ec5af84196c9c5cd026ae5654731)

History

#1 - 08/19/2016 07:33 AM - Daniel Lobato Garcia

- Subject changed from Cannot rebuild to Cannot rebuild when proxy from hostgroup is unreachable

This happens for all the attributes, not just realm, it was just meant to be an example

#2 - 08/19/2016 07:35 AM - Dominic Cleal
- Category set to Smart Proxy

#3 - 08/19/2016 12:36 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Daniel Lobato Garcia

- Pull request https://github.com/theforeman/foreman/pull/3752 added

#4 - 08/23/2016 07:01 AM - Daniel Lobato Garcia
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 15f2f2918f60ec5af84196c9c5cd026ae5654731.

#5 - 08/23/2016 07:06 AM - Dominic Cleal

- translation missing: en.field_release set to 181

#6 - 08/23/2016 10:01 AM - Daniel Lobato Garcia

- Target version set to 1.6.2
